package us.jakest.desker

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView

class Adapter (
    //val context: Context,
    private val appList: List<AppBlock>?=null
) :RecyclerView.Adapter<Adapter.ViewHolder>() {

    inner class ViewHolder(itemView: View): RecyclerView.ViewHolder(itemView) {
        val text = itemView.findViewById<TextView>(R.id.appName)!!
        val icon = itemView.findViewById<ImageView>(R.id.appIcon)!!
        //val text: TextView
        //init {
        //    textView = view.findViewById(R.id.textView)
        //    text = view.findViewById(R.id.appName)
        //}
    }

    override fun onCreateViewHolder(viewGroup: ViewGroup, viewType: Int): ViewHolder {
        val context = viewGroup.context
        val inflater = LayoutInflater.from(context)
        val itemView = inflater.inflate(R.layout.item_app, viewGroup, false)
        return ViewHolder(itemView)
    }

    // Replace the contents of a view (invoked by the layout manager)
    override fun onBindViewHolder(viewHolder: Adapter.ViewHolder, position: Int) {
        val context = viewHolder.text.context
        val text = viewHolder.text
        text.text = appList?.get(position)?.name
        val icon = viewHolder.icon
        icon.setImageDrawable(appList?.get(position)?.icon)
        text.rootView.setOnClickListener {
            context.startActivity(
                context.packageManager.getLaunchIntentForPackage(appList?.get(position)?.packageName?:"us.jakest.desker")
            )
        }
    }

    // Return the size of your dataset (invoked by the layout manager)
    override fun getItemCount() = appList?.size?:0

}